import { ErrorResponse } from "../models/ErrorResponse";
export declare type ApiResult<T> = ApiResultSuccess<T> | ApiResultError;
export interface ApiResultSuccess<T> extends ApiResultBase {
    ok: true;
    body: T;
}
export interface ApiResultError extends ApiResultBase {
    ok: false;
    body: Partial<ErrorResponse> | undefined;
}
interface ApiResultBase {
    url: string;
    ok: boolean;
    status: number;
    statusText: string;
}
export {};
