import type { FilePathDefinition } from "./FilePathDefinition";
import type { FileTagName } from "./FileTagName";
import type { MimeType } from "./MimeType";
import type { OriginalFileName } from "./OriginalFileName";
import type { SizeInBytes } from "./SizeInBytes";
import { JsonObject } from "./JsonObject";
import { MultipartUploadProtocol } from "./MultipartUploadProtocol";
/**
 * File upload initialization request.
 */
export declare type BeginUploadRequestV2 = {
    metadata?: JsonObject;
    mime?: MimeType;
    originalFileName?: OriginalFileName;
    path?: FilePathDefinition;
    protocol?: MultipartUploadProtocol;
    size: SizeInBytes;
    tags?: Array<FileTagName>;
};
