import type { EpochMillis } from "./EpochMillis";
import type { FilePath } from "./FilePath";
import type { FileTagName } from "./FileTagName";
import type { HttpUrl } from "./HttpUrl";
import type { MimeType } from "./MimeType";
import type { OriginalFileName } from "./OriginalFileName";
import type { SizeInBytes } from "./SizeInBytes";
import { JsonObject } from "./JsonObject";
export declare type FileDetails = {
    metadata: JsonObject;
    mime: MimeType;
    originalFileName: OriginalFileName | null;
    tags: Array<FileTagName>;
    filePath: FilePath;
    fileUrl: HttpUrl;
    lastModified: EpochMillis;
    size: SizeInBytes;
};
